diff --git a/src/build_tools/code_generator_util.py b/src/build_tools/code_generator_util.py
index d489a7c7..80254e74 100644
--- a/src/build_tools/code_generator_util.py
+++ b/src/build_tools/code_generator_util.py
@@ -33,27 +33,26 @@
 __author__ = "hidehiko"
 
 import struct
-import types
 
 
 def ToCppStringLiteral(s):
   """Returns C-style string literal, or NULL if given s is None."""
   if s is None:
-    return 'NULL'
+    return b'NULL'
 
-  if all(0x20 <= ord(c) <= 0x7E for c in s):
+  if all(0x20 <= c <= 0x7E for c in s):
     # All characters are in ascii code.
-    return '"%s"' % s.replace('\\', r'\\').replace('"', r'\"')
+    return b'"%b"' % s.replace(b'\\', br'\\').replace(b'"', br'\"')
   else:
     # One or more characters are non-ascii.
-    return '"%s"' % ''.join(r'\x%02X' % ord(c) for c in s)
+    return b'"%b"' % b''.join(br'\x%02X' % c for c in s)
 
 
 def FormatWithCppEscape(format_text, *args):
   """Returns a string filling format with args."""
   literal_list = []
   for arg in args:
-    if isinstance(arg, (types.StringType, types.NoneType)):
+    if isinstance(arg, (bytes, type(None))):
       arg = ToCppStringLiteral(arg)
     literal_list.append(arg)
 
@@ -95,7 +94,7 @@ def WriteCppDataArray(data, variable_name, target_compiler, stream):
   if target_compiler and target_compiler.startswith('msvs'):
     stream.write('const uint64 k%s_data_wordtype[] = {\n' % variable_name)
 
-    for word_index in xrange(0, len(data), 8):
+    for word_index in range(0, len(data), 8):
       word_chunk = data[word_index:word_index + 8].ljust(8, '\x00')
       stream.write('0x%016X, ' % struct.unpack('<Q', word_chunk))
       if (word_index / 8) % 4 == 3:
@@ -111,7 +110,7 @@ def WriteCppDataArray(data, variable_name, target_compiler, stream):
     stream.write('const char k%s_data[] =\n' % variable_name)
     # Output 16bytes per line.
     chunk_size = 16
-    for index in xrange(0, len(data), chunk_size):
+    for index in range(0, len(data), chunk_size):
       chunk = data[index:index + chunk_size]
       stream.write('"')
       stream.writelines(r'\x%02X' % ord(c) for c in chunk)
@@ -126,36 +125,50 @@ def ToJavaStringLiteral(codepoint_list):
   if type(codepoint_list) is int:
     codepoint_list = (codepoint_list,)
   if codepoint_list is None or len(codepoint_list) == 0:
-    return 'null'
-  result = r'"'
+    return b'null'
+  result = b'"'
   for codepoint in codepoint_list:
-    utf16_string = unichr(codepoint).encode('utf-16be')
+    utf16_string = chr(codepoint).encode('utf-16be')
     if len(utf16_string) == 2:
       (u0, l0) = utf16_string
-      result += r'\u%02X%02X' % (ord(u0), ord(l0))
+      result += br'\u%02X%02X' % (u0, l0)
     else:
       (u0, l0, u1, l1) = utf16_string
-      result += r'\u%02X%02X\u%02X%02X' % (ord(u0), ord(l0), ord(u1), ord(l1))
-  result += r'"'
+      result += br'\u%02X%02X\u%02X%02X' % (u0, l0, u1, l1)
+  result += b'"'
   return result
 
 
 def SkipLineComment(stream, comment_prefix='#'):
   """Skips line comments from stream."""
   for line in stream:
+    if isinstance(line, bytes):
+      if isinstance(comment_prefix, str):
+        comment_prefix = comment_prefix.encode('utf-8')
+      line_ending = b'\n'
+    else:
+      line_ending = '\n'
     stripped_line = line.strip()
     if stripped_line and not stripped_line.startswith(comment_prefix):
-      yield line.rstrip('\n')
+      yield line.rstrip(line_ending)
 
 
 def ParseColumnStream(stream, num_column=None, delimiter=None):
   """Returns parsed columns read from stream."""
   if num_column is None:
     for line in stream:
-      yield line.rstrip('\n').split(delimiter)
+      if isinstance(line, bytes):
+        line_ending = b'\n'
+      else:
+        line_ending = '\n'
+      yield line.rstrip(line_ending).split(delimiter)
   else:
     for line in stream:
-      yield line.rstrip('\n').split(delimiter)[:num_column]
+      if isinstance(line, bytes):
+        line_ending = b'\n'
+      else:
+        line_ending = '\n'
+      yield line.rstrip(line_ending).split(delimiter)[:num_column]
 
 
 def SelectColumn(stream, column_index):
@@ -172,5 +185,5 @@ def SplitChunk(iterable, n):
   grouper extends the last chunk to make it an n-element chunk by adding
   appropriate value, but this returns truncated chunk.
   """
-  for index in xrange(0, len(iterable), n):
+  for index in range(0, len(iterable), n):
     yield iterable[index:index + n]
diff --git a/src/build_tools/codesign_mac.py b/src/build_tools/codesign_mac.py
index 9c1ba137..a558e048 100644
--- a/src/build_tools/codesign_mac.py
+++ b/src/build_tools/codesign_mac.py
@@ -46,17 +46,17 @@ import sys
 
 def RunOrDie(command):
   """Run the command, or die if it failed."""
-  print "Running: " + command
+  print("Running: " + command)
   try:
     output = subprocess.check_output(command, shell=True)
-    print >> sys.stderr, "=========="
-    print >> sys.stderr, "COMMAND: " + command
-    print >> sys.stderr, output
+    print("==========", file=sys.stderr)
+    print("COMMAND: " + command, file=sys.stderr)
+    print(output, file=sys.stderr)
   except subprocess.CalledProcessError as e:
-    print >> sys.stderr, "=========="
-    print >> sys.stderr, "ERROR: " + command
-    print >> sys.stderr, e.output
-    print >> sys.stderr, "=========="
+    print("==========", file=sys.stderr)
+    print("ERROR: " + command, file=sys.stderr)
+    print(e.output, file=sys.stderr)
+    print("==========", file=sys.stderr)
     sys.exit(1)
 
 
@@ -119,18 +119,18 @@ def ParseOption():
   (options, unused_args) = parser.parse_args()
 
   if not options.target:
-    print "Error: --target should be specified."
-    print parser.print_help()
+    print("Error: --target should be specified.")
+    print(parser.print_help())
     sys.exit(1)
 
   return options
 
 
 def DumpEnviron():
-  print "=== os.environ ==="
+  print("=== os.environ ===")
   for key in sorted(os.environ):
-    print "%s = %s" % (key, os.getenv(key))
-  print "=================="
+    print("%s = %s" % (key, os.getenv(key)))
+  print("==================")
 
 
 def main():
diff --git a/src/build_tools/copy_dll_and_symbol.py b/src/build_tools/copy_dll_and_symbol.py
index 5bc0fe23..72f2788b 100644
--- a/src/build_tools/copy_dll_and_symbol.py
+++ b/src/build_tools/copy_dll_and_symbol.py
@@ -38,7 +38,7 @@ import optparse
 import os
 import shutil
 
-from util import PrintErrorAndExit
+from .util import PrintErrorAndExit
 
 def ParseOption():
   """Parse command line options."""
@@ -98,7 +98,7 @@ def DeployMain(full_filename, src_paths, target_absdir):
     if _GetLastModifiedTime(src) <= target_file_mtime:
       # Older file found. Ignore.
       continue
-    print 'Copying %s to %s' % (src, target_file_abspath)
+    print('Copying %s to %s' % (src, target_file_abspath))
     shutil.copy2(src, target_file_abspath)
     break
 
diff --git a/src/build_tools/copy_file.py b/src/build_tools/copy_file.py
index 92b5ef3e..7268fd7b 100644
--- a/src/build_tools/copy_file.py
+++ b/src/build_tools/copy_file.py
@@ -52,7 +52,7 @@ def _ErrorExit(message):
   Args:
     message: The error message to be printed to stderr.
   """
-  print >>sys.stderr, message
+  print(message, file=sys.stderr)
   sys.exit(1)
 
 
diff --git a/src/build_tools/copy_qt_frameworks_mac.py b/src/build_tools/copy_qt_frameworks_mac.py
index 2f7be942..8360e81e 100644
--- a/src/build_tools/copy_qt_frameworks_mac.py
+++ b/src/build_tools/copy_qt_frameworks_mac.py
@@ -41,9 +41,9 @@ __author__ = "horo"
 import optparse
 import os
 
-from copy_file import CopyFiles
-from util import PrintErrorAndExit
-from util import RunOrDie
+from .copy_file import CopyFiles
+from .util import PrintErrorAndExit
+from .util import RunOrDie
 
 
 def ParseOption():
diff --git a/src/build_tools/embed_file.py b/src/build_tools/embed_file.py
index 743f4f0d..9461d74b 100644
--- a/src/build_tools/embed_file.py
+++ b/src/build_tools/embed_file.py
@@ -46,10 +46,10 @@ def _ParseOption():
 
 def _FormatAsUint64LittleEndian(s):
   """Formats a string as uint64 value in little endian order."""
-  for _ in xrange(len(s), 8):
-    s += '\0'
+  for _ in range(len(s), 8):
+    s += b'\0'
   s = s[::-1]  # Reverse the string
-  return '0x%s' % binascii.b2a_hex(s)
+  return b'0x%b' % binascii.b2a_hex(s)
 
 
 def main():
@@ -57,30 +57,30 @@ def main():
   with open(opts.input, 'rb') as infile:
     with open(opts.output, 'wb') as outfile:
       outfile.write(
-          '#ifdef MOZC_EMBEDDED_FILE_%(name)s\n'
-          '#error "%(name)s was already included or defined elsewhere"\n'
-          '#else\n'
-          '#define MOZC_EMBEDDED_FILE_%(name)s\n'
-          'const uint64 %(name)s_data[] = {\n'
-          % {'name': opts.name})
+          b'#ifdef MOZC_EMBEDDED_FILE_%(name)b\n'
+          b'#error "%(name)b was already included or defined elsewhere"\n'
+          b'#else\n'
+          b'#define MOZC_EMBEDDED_FILE_%(name)b\n'
+          b'const uint64 %(name)b_data[] = {\n'
+          % {b'name': opts.name.encode('utf-8')})
 
       while True:
         chunk = infile.read(8)
         if not chunk:
           break
-        outfile.write('  ')
+        outfile.write(b'  ')
         outfile.write(_FormatAsUint64LittleEndian(chunk))
-        outfile.write(',\n')
+        outfile.write(b',\n')
 
       outfile.write(
-          '};\n'
-          'const EmbeddedFile %(name)s = {\n'
-          '  %(name)s_data,\n'
-          '  %(size)d,\n'
-          '};\n'
-          '#endif  // MOZC_EMBEDDED_FILE_%(name)s\n'
-          % {'name': opts.name,
-             'size': os.stat(opts.input).st_size})
+          b'};\n'
+          b'const EmbeddedFile %(name)b = {\n'
+          b'  %(name)b_data,\n'
+          b'  %(size)d,\n'
+          b'};\n'
+          b'#endif  // MOZC_EMBEDDED_FILE_%(name)b\n'
+          % {b'name': opts.name.encode('utf-8'),
+             b'size': os.stat(opts.input).st_size})
 
 
 if __name__ == '__main__':
diff --git a/src/build_tools/embed_pathname.py b/src/build_tools/embed_pathname.py
index d7424f38..888e704f 100644
--- a/src/build_tools/embed_pathname.py
+++ b/src/build_tools/embed_pathname.py
@@ -28,7 +28,7 @@
 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
-"""A script to embed the given (relative) path name to C/C++ characters array.
+r"""A script to embed the given (relative) path name to C/C++ characters array.
 
 Example:
   ./embed_pathname.py --path_to_be_embedded=d:\data\mozc
@@ -53,7 +53,7 @@ def ParseOption():
 
   (options, unused_args) = parser.parse_args()
   if not all(vars(options).values()):
-    print parser.print_help()
+    print(parser.print_help())
     sys.exit(1)
 
   return options
@@ -63,7 +63,7 @@ def main():
   opt = ParseOption()
   path = os.path.abspath(opt.path_to_be_embedded)
   # TODO(yukawa): Consider the case of non-ASCII characters.
-  escaped_path = path.encode('string-escape')
+  escaped_path = path.replace('\\', '\\\\')
   with open(opt.output, 'w') as output_file:
     output_file.write(
         'const char %s[] = "%s";\n' % (opt.constant_name, escaped_path))
diff --git a/src/build_tools/ensure_gyp_module_path.py b/src/build_tools/ensure_gyp_module_path.py
index 2ba74c9e..13344427 100644
--- a/src/build_tools/ensure_gyp_module_path.py
+++ b/src/build_tools/ensure_gyp_module_path.py
@@ -48,7 +48,7 @@ def ParseOption():
 
   (options, _) = parser.parse_args()
   if not options.expected:
-    print parser.print_help()
+    print(parser.print_help())
     sys.exit(1)
 
   return options
@@ -59,20 +59,20 @@ def main():
   opt = ParseOption()
   expected_path = os.path.abspath(opt.expected)
   if not os.path.exists(expected_path):
-    print '%s does not exist.' % expected_path
+    print('%s does not exist.' % expected_path)
     sys.exit(1)
 
   try:
     import gyp  # NOLINT
   except ImportError as e:
-    print 'import gyp failed: %s' % e
+    print('import gyp failed: %s' % e)
     sys.exit(1)
 
   actual_path = os.path.abspath(gyp.__path__[0])
   if expected_path != actual_path:
-    print 'Unexpected gyp module is loaded on this environment.'
-    print '  expected: %s' % expected_path
-    print '  actual  : %s' % actual_path
+    print('Unexpected gyp module is loaded on this environment.')
+    print('  expected: %s' % expected_path)
+    print('  actual  : %s' % actual_path)
     sys.exit(1)
 
 if __name__ == '__main__':
diff --git a/src/build_tools/gen_win32_resource_header.py b/src/build_tools/gen_win32_resource_header.py
index 313c5492..b87599f3 100644
--- a/src/build_tools/gen_win32_resource_header.py
+++ b/src/build_tools/gen_win32_resource_header.py
@@ -39,7 +39,7 @@ See mozc_version.py for the detailed information for version.txt.
 __author__ = "yukawa"
 
 import logging
-import mozc_version
+from . import mozc_version
 import optparse
 import os
 import sys
diff --git a/src/build_tools/mozc_version.py b/src/build_tools/mozc_version.py
index a2e93ec9..694ae4e1 100644
--- a/src/build_tools/mozc_version.py
+++ b/src/build_tools/mozc_version.py
@@ -94,7 +94,7 @@ def _GetRevisionForPlatform(revision, target_platform):
   last_digit = TARGET_PLATFORM_TO_DIGIT.get(target_platform, None)
   if last_digit is None:
     logging.critical('target_platform %s is invalid. Accetable ones are %s',
-                     target_platform, TARGET_PLATFORM_TO_DIGIT.keys())
+                     target_platform, list(TARGET_PLATFORM_TO_DIGIT.keys()))
     sys.exit(1)
 
   if not revision:
@@ -314,13 +314,14 @@ class MozcVersion(object):
     self._properties = {}
     if not os.path.isfile(path):
       return
-    for line in open(path):
-      matchobj = re.match(r'(\w+)=(.*)', line.strip())
-      if matchobj:
-        var = matchobj.group(1)
-        val = matchobj.group(2)
-        if var not in self._properties:
-          self._properties[var] = val
+    with open(path) as file:
+      for line in file:
+        matchobj = re.match(r'(\w+)=(.*)', line.strip())
+        if matchobj:
+          var = matchobj.group(1)
+          val = matchobj.group(2)
+          if var not in self._properties:
+            self._properties[var] = val
 
     # Check mandatory properties.
     for key in VERSION_PROPERTIES:
diff --git a/src/build_tools/redirect.py b/src/build_tools/redirect.py
index fc78ef60..68f4eacc 100644
--- a/src/build_tools/redirect.py
+++ b/src/build_tools/redirect.py
@@ -58,14 +58,15 @@ def main():
     process = subprocess.Popen(sys.argv, stdout=subprocess.PIPE,
                                universal_newlines=True)
   except:
-    print '=========='
-    print ' ERROR: %s' % ' '.join(sys.argv)
-    print '=========='
+    print('==========')
+    print(' ERROR: %s' % ' '.join(sys.argv))
+    print('==========')
     raise
   (stdout_content, _) = process.communicate()
   # Write the stdout content to the output file.
   output_file = open(output_file_name, 'w')
   output_file.write(stdout_content)
+  output_file.close()
   return process.wait()
 
 if __name__ == '__main__':
diff --git a/src/build_tools/run_after_chdir.py b/src/build_tools/run_after_chdir.py
index 9e063109..f7519c13 100644
--- a/src/build_tools/run_after_chdir.py
+++ b/src/build_tools/run_after_chdir.py
@@ -57,7 +57,7 @@ def main():
     sys.argv.insert(0, sys.executable)  # Inject the python interpreter path.
   # We don't capture stdout and stderr from Popen. The output will just
   # be emitted to a terminal or console.
-  print sys.argv
+  print(sys.argv)
   sys.exit(subprocess.call(sys.argv))
 
 if __name__ == '__main__':
diff --git a/src/build_tools/serialized_string_array_builder.py b/src/build_tools/serialized_string_array_builder.py
index f045a22c..7a2c29c6 100644
--- a/src/build_tools/serialized_string_array_builder.py
+++ b/src/build_tools/serialized_string_array_builder.py
@@ -58,11 +58,11 @@ def SerializeToFile(strings, filename):
     f.write(struct.pack('<I', array_size))
 
     # Offset and length array of (4 + 4) * array_size bytes.
-    for i in xrange(array_size):
+    for i in range(array_size):
       f.write(struct.pack('<I', offsets[i]))
       f.write(struct.pack('<I', lengths[i]))
 
     # Strings chunk.
-    for i in xrange(array_size):
+    for i in range(array_size):
       f.write(strings[i])
-      f.write('\0')
+      f.write(b'\0')
diff --git a/src/build_tools/test_tools/gtest_report.py b/src/build_tools/test_tools/gtest_report.py
index 3a161e1d..e01d28e7 100644
--- a/src/build_tools/test_tools/gtest_report.py
+++ b/src/build_tools/test_tools/gtest_report.py
@@ -36,9 +36,9 @@ store as python object.
 
 __author__ = "nona"
 
-import cStringIO as StringIO
+import io
 import logging
-from xml.etree import cElementTree as ElementTree
+from xml.etree import ElementTree
 
 
 class Failure(object):
@@ -87,13 +87,13 @@ class TestSuite(object):
     """Returns summarized error report text."""
     if self.fail_num == 0:
       return ''
-    output = StringIO.StringIO()
+    output = io.StringIO()
     for testcase in self.testcases:
       if not testcase.failures:
         continue
-      print >>output, '%s.%s:' % (self.name, testcase.name)
+      print('%s.%s:' % (self.name, testcase.name), file=output)
       for failure in testcase.failures:
-        print >>output, failure.contents.encode('utf-8')
+        print(failure.contents.encode('utf-8'), file=output)
     return output.getvalue()
 
   @classmethod
diff --git a/src/build_tools/test_tools/test_launcher.py b/src/build_tools/test_tools/test_launcher.py
index 47c0a2ec..1b5cecfc 100644
--- a/src/build_tools/test_tools/test_launcher.py
+++ b/src/build_tools/test_tools/test_launcher.py
@@ -101,11 +101,11 @@ class PathDeleter(object):
       time.sleep(1)
       try:
         shutil.rmtree(self._path)
-      except OSError, e:
+      except OSError as e:
         logging.error('Failed to remove %s. error: %s', self._path, e)
 
 
-def _ExecuteTest((command, gtest_report_dir)):
+def _ExecuteTest(args):
   """Executes tests with specified Test command.
 
   Args:
@@ -122,6 +122,7 @@ def _ExecuteTest((command, gtest_report_dir)):
   module, which is used in multiprocessing module.
   (http://docs.python.org/library/pickle.html)
   """
+  (command, gtest_report_dir) = args
   binary = command[0]
   binary_filename = os.path.basename(binary)
   tmp_dir = tempfile.mkdtemp()
diff --git a/src/build_tools/tweak_data.py b/src/build_tools/tweak_data.py
index 64d57e14..79b70c49 100644
--- a/src/build_tools/tweak_data.py
+++ b/src/build_tools/tweak_data.py
@@ -55,7 +55,7 @@ def ReplaceVariables(data, environment):
       The value for the variable if the variable is defined in the
       environment.  Otherwise original string is returned.
     """
-    if environment.has_key(matchobj.group(1)):
+    if matchobj.group(1) in environment:
       return environment[matchobj.group(1)]
     return matchobj.group(0)
 
diff --git a/src/build_tools/tweak_info_plist.py b/src/build_tools/tweak_info_plist.py
index efa3b268..1ff91e2c 100644
--- a/src/build_tools/tweak_info_plist.py
+++ b/src/build_tools/tweak_info_plist.py
@@ -42,8 +42,8 @@ import datetime
 import logging
 import optparse
 import sys
-import mozc_version
-import tweak_data
+from . import mozc_version
+from . import tweak_data
 
 _COPYRIGHT_YEAR = datetime.date.today().year
 
@@ -81,7 +81,7 @@ def main():
 
   version = mozc_version.MozcVersion(options.version_file)
 
-  copyright_message = (u'© %d Google Inc.' % _COPYRIGHT_YEAR).encode('utf-8')
+  copyright_message = ('© %d Google Inc.' % _COPYRIGHT_YEAR).encode('utf-8')
   long_version = version.GetVersionString()
   short_version = version.GetVersionInFormat('@MAJOR@.@MINOR@.@BUILD@')
 
diff --git a/src/build_tools/tweak_info_plist_strings.py b/src/build_tools/tweak_info_plist_strings.py
index e34dd59a..bdd00168 100644
--- a/src/build_tools/tweak_info_plist_strings.py
+++ b/src/build_tools/tweak_info_plist_strings.py
@@ -40,7 +40,7 @@ import datetime
 import logging
 import optparse
 import sys
-import tweak_data
+from . import tweak_data
 
 _COPYRIGHT_YEAR = datetime.date.today().year
 
@@ -77,7 +77,7 @@ def main():
   if options.branding == 'GoogleJapaneseInput':
     variables = {
         'CF_BUNDLE_NAME_EN': 'Google Japanese Input',
-        'CF_BUNDLE_NAME_JA': u'Google 日本語入力'.encode('utf-8'),
+        'CF_BUNDLE_NAME_JA': 'Google 日本語入力'.encode('utf-8'),
         'NS_HUMAN_READABLE_COPYRIGHT': copyright_message,
         'INPUT_MODE_ANNOTATION': 'Google',
         }
diff --git a/src/build_tools/tweak_macinstaller_script.py b/src/build_tools/tweak_macinstaller_script.py
index 54542cbe..daed224c 100644
--- a/src/build_tools/tweak_macinstaller_script.py
+++ b/src/build_tools/tweak_macinstaller_script.py
@@ -39,7 +39,7 @@ __author__ = "mukai"
 import logging
 import optparse
 
-import mozc_version
+from . import mozc_version
 
 
 def _ReplaceVariables(data, environment):
diff --git a/src/build_tools/tweak_pkgproj.py b/src/build_tools/tweak_pkgproj.py
index f5ff7287..84f24ffe 100644
--- a/src/build_tools/tweak_pkgproj.py
+++ b/src/build_tools/tweak_pkgproj.py
@@ -45,7 +45,7 @@ import optparse
 import os
 import plistlib
 import re
-import mozc_version
+from . import mozc_version
 
 from os import path
 
@@ -71,7 +71,7 @@ def _ReplaceVariables(data, environment):
       The value for the variable if the variable is defined in the
       environment.  Otherwise original string is returned.
     """
-    if environment.has_key(matchobj.group(1)):
+    if matchobj.group(1) in environment:
       return environment[matchobj.group(1)]
     return matchobj.group(0)
 
diff --git a/src/build_tools/util.py b/src/build_tools/util.py
index 85961187..f0ef68d9 100644
--- a/src/build_tools/util.py
+++ b/src/build_tools/util.py
@@ -73,11 +73,11 @@ def GetNumberOfProcessors():
   return 1
 
 
-class RunOrDieError(StandardError):
+class RunOrDieError(Exception):
   """The exception class for RunOrDie."""
 
   def __init__(self, message):
-    StandardError.__init__(self, message)
+    Exception.__init__(self, message)
 
 
 def RunOrDie(argv):
@@ -105,7 +105,7 @@ def RemoveFile(file_name):
     return  # Do nothing if not exist.
   if IsWindows():
     # Read-only files cannot be deleted on Windows.
-    os.chmod(file_name, 0700)
+    os.chmod(file_name, 0o700)
   logging.debug('Removing file: %s', file_name)
   os.unlink(file_name)
 
diff --git a/src/build_tools/zlib_util.py b/src/build_tools/zlib_util.py
index 47491480..cc6630b0 100644
--- a/src/build_tools/zlib_util.py
+++ b/src/build_tools/zlib_util.py
@@ -58,7 +58,7 @@ def Decompress(input_filename, output_filename):
 
 def main():
   if len(sys.argv) != 4:
-    print >>sys.stderr, 'Invalid arguments'
+    print('Invalid arguments', file=sys.stderr)
     return
   if sys.argv[1] == 'compress':
     Compress(sys.argv[2], sys.argv[3])
@@ -66,7 +66,7 @@ def main():
   if sys.argv[1] == 'decompress':
     Decompress(sys.argv[2], sys.argv[3])
     return
-  print >>sys.stderr, 'Unknown command:', sys.argv[1]
+  print('Unknown command:', sys.argv[1], file=sys.stderr)
 
 
 if __name__ == '__main__':
diff --git a/src/chrome/nacl/nacl_net_test_server.py b/src/chrome/nacl/nacl_net_test_server.py
index 257fa79e..e88e10dc 100644
--- a/src/chrome/nacl/nacl_net_test_server.py
+++ b/src/chrome/nacl/nacl_net_test_server.py
@@ -45,27 +45,27 @@ Example usage:
     --timeout=20
 """
 
-import BaseHTTPServer
+import _thread
+import http.server
 import optparse
 import os
 import os.path
 import shutil
-import SocketServer
+import socketserver
 import subprocess
 import sys
 import tempfile
-import thread
 import time
-import urlparse
+import urllib.parse
 
 
-class RequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
+class RequestHandler(http.server.BaseHTTPRequestHandler):
   """Handle the HTTP requests that arrive at the server."""
 
   def do_GET(self):
   # pylint: disable=g-bad-name
     """Handles GET request."""
-    parsed_path = urlparse.urlparse(self.path)
+    parsed_path = urllib.parse.urlparse(self.path)
     options = {'response': 200,
                'result': '',
                'before_response_sleep': 0.0,
@@ -77,7 +77,7 @@ class RequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
                'data': 'DEFAULT_DATA',
                'times': 1,
                'redirect_location': ''}
-    query = urlparse.parse_qsl(parsed_path.query)
+    query = urllib.parse.parse_qsl(parsed_path.query)
     for params in query:
       options[params[0]] = params[1]
 
@@ -113,13 +113,14 @@ class RequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
       full_path = os.path.join(extra_dir, os.path.basename(parsed_path.path))
       if os.path.isfile(full_path):
         try:
-          data = open(full_path).read()
+          with open(full_path) as f:
+            data = f.read()
           self.send_response(200)
           self.send_header('Content-Length', len(data))
           self.end_headers()
           self.wfile.write(data)
-        except IOError, (errno, strerror):
-          print 'I/O error(%s): %s' % (errno, strerror)
+        except IOError as e:
+          print('I/O error(%s): %s' % (e.errno, e.strerror))
         return
 
     try:
@@ -143,14 +144,14 @@ class RequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
         time.sleep(float(options['before_data_sleep']))
         self.wfile.write(options['data'])
         time.sleep(float(options['after_data_sleep']))
-    except IOError, (errno, strerror):
-      print 'I/O error(%s): %s' % (errno, strerror)
+    except IOError as e:
+      print('I/O error(%s): %s' % (e.errno, e.strerror))
     return
 
   def do_POST(self):
   # pylint: disable=g-bad-name
     """Handles POST request."""
-    parsed_path = urlparse.urlparse(self.path)
+    parsed_path = urllib.parse.urlparse(self.path)
     options = {'response': 200,
                'result': '',
                'before_response_sleep': 0.0,
@@ -159,7 +160,7 @@ class RequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
                'after_data_sleep': 0.0,
                'content_length': '',
                'redirect_location': ''}
-    query = urlparse.parse_qsl(parsed_path.query)
+    query = urllib.parse.parse_qsl(parsed_path.query)
     for params in query:
       options[params[0]] = params[1]
 
@@ -185,18 +186,18 @@ class RequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
       self.wfile.write(post_data)
       time.sleep(float(options['after_data_sleep']))
       return
-    except IOError, (errno, strerror):
-      print 'I/O error(%s): %s' % (errno, strerror)
+    except IOError as e:
+      print('I/O error(%s): %s' % (e.errno, e.strerror))
     return
 
   def do_HEAD(self):
   # pylint: disable=g-bad-name
     """Handles HEAD request."""
-    parsed_path = urlparse.urlparse(self.path)
+    parsed_path = urllib.parse.urlparse(self.path)
     options = {'response': 200,
                'before_response_sleep': 0.0,
                'before_head_sleep': 0.0}
-    query = urlparse.parse_qsl(parsed_path.query)
+    query = urllib.parse.parse_qsl(parsed_path.query)
     for params in query:
       options[params[0]] = params[1]
 
@@ -210,12 +211,12 @@ class RequestHandler(BaseHTTPServer.BaseHTTPRequestHandler):
       for name, value in sorted(self.headers.items()):
         self.send_header('CLIENT_HEADER_%s' % name, '%s' % value)
       self.end_headers()
-    except IOError, (errno, strerror):
-      print 'I/O error(%s): %s' % (errno, strerror)
+    except IOError as e:
+      print('I/O error(%s): %s' % (e.errno, e.strerror))
     return
 
 
-class TestServer(SocketServer.ThreadingMixIn, BaseHTTPServer.HTTPServer):
+class TestServer(socketserver.ThreadingMixIn, http.server.HTTPServer):
   def Configure(self, serving_dirs):
     self.serving_dirs = serving_dirs
     self.finished = False
@@ -243,12 +244,12 @@ def main():
   server = TestServer(('localhost', 9999), RequestHandler)
   server.Configure(options.serving_dirs)
   host, port = server.socket.getsockname()
-  print 'Starting server %s:%s' % (host, port)
+  print('Starting server %s:%s' % (host, port))
 
   def Serve():
     while not server.finished:
       server.handle_request()
-  thread.start_new_thread(Serve, ())
+  _thread.start_new_thread(Serve, ())
 
   temp_dir = tempfile.mkdtemp()
   if options.browser_path:
@@ -257,7 +258,7 @@ def main():
       cmd.append('--load-extension=%s' % options.load_extension)
     if options.url:
       cmd.append('http://%s:%s/%s' % (host, port, options.url))
-    print cmd
+    print(cmd)
     browser_handle = subprocess.Popen(cmd)
 
   time_started = time.time()
diff --git a/src/chrome/nacl/pnacl_translate.py b/src/chrome/nacl/pnacl_translate.py
index ae10b3c1..02b037d0 100644
--- a/src/chrome/nacl/pnacl_translate.py
+++ b/src/chrome/nacl/pnacl_translate.py
@@ -54,11 +54,11 @@ def Translate(toolchain_root, input_file, output_base):
   for target in targets:
     cmd = (translate_command, '--allow-llvm-bitcode-input', '-arch', target[0],
            input_file, '-o', '%s_%s.nexe' % (output_base, target[1]))
-    print 'Running: ' + ' '.join(cmd)
+    print('Running: ' + ' '.join(cmd))
     if subprocess.Popen(cmd).wait() != 0:
-      print >> sys.stderr, 'ERROR: ' + ' '.join(cmd)
+      print('ERROR: ' + ' '.join(cmd), file=sys.stderr)
       raise RuntimeError('Translate Error')
-    print 'Done: ' + ' '.join(cmd)
+    print('Done: ' + ' '.join(cmd))
 
 
 def StripAndTranslate(toolchain_root, input_file, output_base):
@@ -68,21 +68,21 @@ def StripAndTranslate(toolchain_root, input_file, output_base):
     temp_dir = tempfile.mkdtemp()
     temp_file_base = os.path.join(temp_dir, 'stripped')
     cmd = (strip_command, input_file, '-o', temp_file_base)
-    print 'Running: ' + ' '.join(cmd)
+    print('Running: ' + ' '.join(cmd))
     if subprocess.Popen(cmd).wait() != 0:
-      print >> sys.stderr, 'ERROR: ' + ' '.join(cmd)
+      print('ERROR: ' + ' '.join(cmd), file=sys.stderr)
       raise RuntimeError('Strip Error')
-    print 'Done: ' + ' '.join(cmd)
+    print('Done: ' + ' '.join(cmd))
     Translate(toolchain_root, temp_file_base, temp_file_base)
     targets = ('arm', 'x86_32', 'x86_64')
     for target in targets:
       cmd = (strip_command, '%s_%s.nexe' % (temp_file_base, target),
              '-o', '%s_%s.nexe' % (output_base, target))
-      print 'Running: ' + ' '.join(cmd)
+      print('Running: ' + ' '.join(cmd))
       if subprocess.Popen(cmd).wait() != 0:
-        print >> sys.stderr, 'ERROR: ' + ' '.join(cmd)
+        print('ERROR: ' + ' '.join(cmd), file=sys.stderr)
         raise RuntimeError('Strip Error')
-      print 'Done: ' + ' '.join(cmd)
+      print('Done: ' + ' '.join(cmd))
   finally:
     shutil.rmtree(temp_dir)
 
@@ -101,15 +101,15 @@ def main():
   (options, _) = parser.parse_args()
 
   if not options.toolchain_root:
-    print >> sys.stderr, 'Error: toolchain_root is not set.'
+    print('Error: toolchain_root is not set.', file=sys.stderr)
     sys.exit(1)
 
   if not options.input:
-    print >> sys.stderr, 'Error: input is not set.'
+    print('Error: input is not set.', file=sys.stderr)
     sys.exit(1)
 
   if not options.output_base:
-    print >> sys.stderr, 'Error: output_base is not set.'
+    print('Error: output_base is not set.', file=sys.stderr)
     sys.exit(1)
 
   if options.configuration == 'Release':
diff --git a/src/chrome/nacl/run_nacl_test.py b/src/chrome/nacl/run_nacl_test.py
index 6a7fcf2f..8a1bea19 100644
--- a/src/chrome/nacl/run_nacl_test.py
+++ b/src/chrome/nacl/run_nacl_test.py
@@ -73,7 +73,7 @@ def RunCommand(options, command):
   output, _ = process.communicate()
   logging.info(output)
   if process.returncode != 0:
-    raise StandardError('Failed to run the command: ' + ' '.join(args))
+    raise Exception('Failed to run the command: ' + ' '.join(args))
   return output
 
 
